; tiny/theme.jl


(let*
  (
    (font (get-font "-*-lucida-medium-r-normal-*-*-100-*-*-p-*-iso8859-1"))
    (font-colors (list "#666666" "#2c2cc1"))

    (title-width
          (lambda (w)
	     (let
	       ((w-width (car (window-dimensions w))))
	       (max 0 (+ 40 (min (- w-width 75)
               (text-width (window-name w) font)))))))

    (update-title-width
          (lambda (w)
	    (if (eq (window-get w 'current-frame-style) 'tiny)
	       (rebuild-frame w))))

        (inset-images (list (set-image-border
	                    (make-image "title-inset-inactive.png") 10 10 0 0)
	                    (set-image-border
			    (make-image "title-inset-active.png")10 10 0 0)))

     	(iconify-images (list (make-image "iconify-normal.png")
			      nil nil
                              (make-image "iconify-clicked.png")))

     	(maximize-images (list (make-image "maximize-normal.png")
                               nil nil
  	 		       (make-image "maximize-clicked.png")))

     	(close-images (list (make-image "close-normal.png")
			    nil nil
                            (make-image "close-clicked.png")))

        
	(menu-images (list (make-image "menu-normal.png")
	                   nil nil
			   (make-image "menu-clicked.png")))
	
	
	
	(border-image (make-image "border.png"))
	
        (corner-tl-2 (make-image "corner_top_left_2.png"))
	(corner-tr-2 (make-image "corner_top_right_2.png"))
	(corner-bl-2 (make-image "corner_bottom_left_2.png"))
	(corner-br-2 (make-image "corner_bottom_right_2.png"))
				

     	(frame `(
		
		((background . ,border-image)
		  (top-edge . -2)
		  (left-edge . ,(lambda (w) (+ (title-width w) 34)))
                  (right-edge . -2)
		  (class . top-border))
		  
		((background . ,border-image)
		  (top-edge . -2)
                  (bottom-edge . -2)
                  (right-edge . -2)
		  (class . right-border))
		  
		((background . ,border-image)
		  (top-edge . -2)
		  (bottom-edge . -2)
                  (left-edge . -2)
                  (class . left-border))
		 
		((background . ,border-image)
		  (right-edge . -2)
		  (bottom-edge . -2)
                  (left-edge . -2)
                  (class . bottom-border))
		
		((background . ,inset-images)
		 (foreground . ,font-colors)
		 (font . ,font)
		 (text . ,window-name)
		 (x-justify . center)
                 (y-justify . center)
		 (top-edge . -12)		  
		 (left-edge . 10)
		 (width . ,(lambda (w) (title-width w)))
		 (class . title))

		((background . ,menu-images)
		 (top-edge . -12)
		 (left-edge . -2)
                 (class . menu-button))
				
		((background . ,iconify-images)
      		 (top-edge . -12)
		 (left-edge . ,(lambda (w) (+ (title-width w) -2))) 
		 (class . iconify-button))

     		((background . ,maximize-images)
      		 (top-edge . -12)
      		 (left-edge . ,(lambda (w) (+ (title-width w) 10)))
      		 (class . maximize-button))

    		((background . ,close-images)
      		 (top-edge . -12)
      		 (left-edge . ,(lambda (w) (+ (title-width w) 22)))
      		 (class . close-button))

     		((background . ,corner-bl-2)
      		 (bottom-edge . -2)
      		 (left-edge . -2)  
      		 (class . bottom-left-corner))

     		((background . ,corner-br-2)
      		 (bottom-edge . -2)
      		 (right-edge . -2) 
      		 (class . bottom-right-corner))
	))

	(shaped-frame `(
  	 
		 ((background . ,inset-images)
		  (foreground . ,font-colors)
		  (font . ,font)
		  (text . ,window-name)
                  (x-justify . center)
		  (y-justify . center)
		  (top-edge . -12)
                  (left-edge . 10)
                  (width . ,(lambda (w) (title-width w)))
		  (class . title))

                ((background . ,menu-images)
		 (top-edge . -12)
		 (left-edge . -2)
		 (class . menu-button))


     		((background . ,iconify-images)
      		 (top-edge . -12)
      		 (left-edge . ,(lambda (w) (+ (title-width w) -2))) 
      		 (class . iconify-button))

     		((background . ,maximize-images)
      		 (top-edge . -12)
      		 (left-edge . ,(lambda (w) (+ (title-width w) 10)))
      		 (class . maximize-button))

     		((background . ,close-images)
      		 (top-edge . -12)
      		 (left-edge . ,(lambda (w) (+ (title-width w) 22)))
      		 (class . close-button))
  
	))

	(transient-frame `(

                 ((background . ,border-image)
                  (top-edge . -2)
		  (left-edge . -2)
                  (right-edge . -2)
		  (class . title))
				    
		 ((background . ,border-image)
                  (top-edge . -2)
                  (bottom-edge . -2)
		  (right-edge . -2)
		  (class . right-border))
						      
                 ((background . ,border-image)
                  (top-edge . -2)
		  (bottom-edge . -2)
		  (left-edge . -2)
                  (class . left-border))

                 ((background . ,border-image)
		  (right-edge . -2)
		  (bottom-edge . -2)
                  (left-edge . -2)
                  (class . bottom-border))

                ((background . ,corner-tl-2)
      		 (top-edge . -2)
      		 (left-edge . -2)
      		 (class . top-left-corner))

     		((background . ,corner-tr-2)
      		 (top-edge . -2)
      		 (right-edge . -2)
      		 (class . top-right-corner))

     		((background . ,corner-bl-2)
      		 (bottom-edge . -2)
      		 (left-edge . -2)  
      		 (class . bottom-left-corner))

     		((background . ,corner-br-2)
      		 (bottom-edge . -2)
      		 (right-edge . -2) 
      		 (class . bottom-right-corner))
	))
	
	(shaped-transient-frame `(
		 
		 ((background . ,inset-images)
		  (foreground . ,font-colors)
		  (font . ,font)
		  (text . ,window-name)
                  (x-justify . center)
		  (y-justify . center)
		  (top-edge . -12)
		  (left-edge . 12)
                  (width . ,(lambda (w) (title-width w)))
		  (class . title))
		  
		((background . ,menu-images)
		 (top-edge . -12)
		 (left-edge . 0)
		 (class . menu-button))

     		((background . ,iconify-images)
      		 (top-edge . -12)
      		 (left-edge . ,(lambda (w) (+ (title-width w) -2))) 
      		 (class . iconify-button))

     		((background . ,close-images)
      		 (top-edge . -12)
      		 (left-edge . ,(lambda (w) (+ (title-width w) 10)))
      		 (class . close-button))

	))
	
  )
  
  (add-frame-style 'tiny
      (lambda (w type)
          (case type
            ((default) frame)
            ((transient) transient-frame)
            ((shaped) shaped-frame)
            ((shaped-transient) shaped-transient-frame))))
                   
		                    
  (call-after-property-changed
      'WM_NAME (lambda ()
	    (rebuild-frames-with-style 'tiny))))
	      
	      
